% BS1 
% xtLogit corr(exch) robust
% var (in the file order): open tedy over cstdr rgrwt inf constant

[D90s varnames]=xlsread('BS1.xls','out sample 9402');
[D70s]=xlsread('BS1.xls','in sample 7593');
BITA=D90s(:,1:7);
BITA(isnan(BITA(:,1)),:)=[];
N_bs=size(BITA,1);    % number of bootstrapping reps
X=D90s(:,8:end-2);
X70s=D70s(:,1:6);
Y=D90s(:,end-1:end);
X(isnan(X(:,1)),:)=[];
X    = [X    ones(size(X,1),1)];      % adding for the constant
X70s = [X70s ones(size(X70s,1),1)];   % adding for the constant

for i=1:N_bs
    logitarg     = sum(repmat(BITA(i,:),size(X,1),1).*X,2);
    logitarg70s  = sum(repmat(BITA(i,:),size(X70s,1),1).*X70s,2);
    PHAT(:,i)    = exp(logitarg)./(1+exp(logitarg));
    PHAT70s(:,i) = exp(logitarg70s)./(1+exp(logitarg70s));
end

ystar   = Y(:,2);
snp     = Y(:,1);
snp70s  = D70s(:,7);
phat70s = D70s(:,8);

% Optimal threshold for phat predicted (no bootstrapping)
[That BAhat]=fminbnd('B_over_A',0,1,[],snp70s,phat70s);
[f M]=B_over_A(That,snp70s,phat70s);
ErrI_snp70s_p = M(1)/(M(1)+M(3));
ErrII_snp70s_p = M(2)/(M(2)+M(4));

% out-sample 94-02 SnP and ystar and in-sample 75-93 snp70s
for i=1:N_bs
    phat=PHAT(:,i);
    phat2=PHAT70s(:,i);
    [T BA]=fminbnd('B_over_A',0,1,[],snp,phat);
    [f M]=B_over_A(T,snp,phat);
    T_snp(i)  = T;
    BA_snp(i) = BA;
    %M_snp(:,:,i)  = M;
    ErrI_snp(i) = M(1)/(M(1)+M(3));
    ErrII_snp(i) = M(2)/(M(2)+M(4));
    [T BA]=fminbnd('B_over_A',0,1,[],ystar,phat);
    [f M]=B_over_A(T,ystar,phat);
    T_ystar(i)  = T;
    BA_ystar(i) = BA;
    %M_ystar(:,:,i)  = M;
    ErrI_ystar(i) = M(1)/(M(1)+M(3));
    ErrII_ystar(i) = M(2)/(M(2)+M(4));
    [T BA]=fminbnd('B_over_A',0,1,[],snp70s,phat2);
    [f M]=B_over_A(T,snp70s,phat70s);
    T_snp70s(i)  = T;
    BA_snp70s(i) = BA;
    %M_snp70s(:,:,i)  = M;
    ErrI_snp70s(i) = M(1)/(M(1)+M(3));
    ErrII_snp70s(i) = M(2)/(M(2)+M(4));
end


% getting the 90th percentile around the mean for Loss and Threshold
% SnP
[snp_sort indx] = sort(BA_snp);
perc = ceil(.05*N_bs);
perc_int_snp=[snp_sort(perc), mean(BA_snp), snp_sort(end-perc)];
T_snp_sort=T_snp(indx);
%T_snp_sort=sort(T_snp);
%perc = ceil(.05*N_bs);
perc_int_snp_T=[T_snp_sort(perc), mean(T_snp), T_snp_sort(end-perc)];
% PesSy
[ystar_sort indx]=sort(BA_ystar);
perc = ceil(.05*N_bs);
perc_int_y=[ystar_sort(perc), mean(BA_ystar)  ystar_sort(end-perc)];
T_ystar_sort=T_ystar(indx);
%T_ystar_sort=sort(T_ystar);
%perc = ceil(.05*N_bs);
perc_int_y_T=[T_ystar_sort(perc), mean(T_ystar)  T_ystar_sort(end-perc)];
% In-Sample
[snp70s_sort indx]=sort(BA_snp70s);
perc = ceil(.05*N_bs);
perc_int_70s=[snp70s_sort(perc), mean(BA_snp70s)  snp70s_sort(end-perc)];
T_snp70s_sort=BA_snp70s(indx);
%T_snp70s_sort=sort(BA_snp70s);
%perc = ceil(.05*N_bs);
perc_int_70s_T=[T_snp70s_sort(perc), mean(T_snp70s)  T_snp70s_sort(end-perc)];

disp('Table 1')
disp('Standard and PesSy distress definition Loss Function Boostrapped results')
disp('10th percentile, mean value, 90th percentile for the Loss Function')
disp('-------------------------------------------------------------------------')
fprintf('Standard definition Loss(out sample):  [%6.3g, %6.3g, %6.3g] \n',perc_int_snp)
fprintf('Associated Threshold:                  [%6.3g, %6.3g, %6.3g] \n',perc_int_snp_T)
disp('-------------------------------------------------------------------------')
fprintf('PesSy definition Loss (out sample): [%6.3g, %6.3g, %6.3g] \n',perc_int_y)
fprintf('Associated Threshold:               [%6.3g, %6.3g, %6.3g] \n',perc_int_y_T)
disp('-------------------------------------------------------------------------')
fprintf('In Sample Result Loss:       %6.3g \n',BAhat)
fprintf('In Sample Result Threshold : %6.3g \n',That)
disp('-------------------------------------------------------------------------')
disp('-------------------------------------------------------------------------')

% performing a t-test for sample means

tail=0;
[h,significance,ci,stats] = ttest2(BA_snp',BA_ystar',.05,tail);

disp('Table 2')
disp('-------------------------------------------------------------------------')
disp('Comparing Standard and PesSy distress definition in term of Loss Function')
disp('-------------------------------------------------------------------------')
fprintf('significance = %6.3g ||   conf. interv. = [ %6.3g, %6.3g ]\n',significance,ci(1),ci(2))
disp('-------------------------------------------------------------------------')
disp('-------------------------------------------------------------------------')


% The Errors
[ErI,indx]=sort(ErrI_snp);
ErI_ci_snp=[ErI(perc), mean(ErrI_snp), ErI(end-perc)];
ErrII_snp=ErrII_snp(indx);
ErII_ci_snp = [ErrII_snp(perc) mean(ErrII_snp) ErrII_snp(end-perc-1)];

[ErI,indx]=sort(ErrI_ystar);
ErI_ci_y=[ErI(perc), mean(ErrI_ystar), ErI(end-perc)];
ErrII_y=ErrII_ystar(indx);
ErII_ci_y = [ErrII_y(perc) mean(ErrII_y) ErrII_y(end-perc-1)];

[ErI,indx]=sort(ErrI_snp70s);
ErI_ci_snp70s=[ErI(2*perc), mean(ErrI_snp70s), ErI(end-2*perc)];
ErrII_snp70s=ErrII_snp70s(indx);
ErII_ci_snp70s = [ErrII_snp70s(1*perc) mean(ErrII_snp70s) ErrII_snp70s(end-1*perc-1)];

disp('Table3')
fprintf('SnP    %6.3g %6.3g %6.3g ||respective Error II at 10th =%6.3g  at mean =%6.3g  at 90th =%6.3g \n',ErI_ci_snp,ErII_ci_snp)
fprintf('PesSy  %6.3g %6.3g %6.3g ||respective Error II at 10th =%6.3g  at mean =%6.3g  at 90th =%6.3g \n',ErI_ci_y,ErII_ci_y)
fprintf('SnP70s %6.3g %6.3g %6.3g ||respective Error II at 10th =%6.3g  at mean =%6.3g  at 90th =%6.3g \n', ...
    ErI_ci_snp70s,ErII_ci_snp70s)

