% hot to call it :  [a s]=fminbnd('B_over_A',0,1,[],y,phat)

%%%% False Alarms over mathced crisis event ratio %%%%

%%% input: the probability threshold (above which a crisis warning is issued)
%%% input: the col vector of actual crises event (y) 
%%% input: the col vector of estimated probabilities (phat)
%%% input: (out_of_min) set to 0 whenever you minimize the function
%%% output: B/A (False Alarms/Matched crises)

function [BA, M] = B_over_A(x, y, phat,out_of_min)

if not(exist('y','var')) | not(exist('phat','var'))
    error('supply y and phat')
end

if min(phat)<0 | max(phat)>1 | max(y)>1 | min(y)<0
    error('phat must be probabilities, y binary zeros ones')
end

if not(exist('out_of_min','var'))
    out_of_min=0;
end

% getting rid of the missing values

indx1 = isnan(y)+0;      % y missing values
indx2 = isnan(phat)+0;   % regressors missing values

indx = (indx1+indx2)<1; % logical, zeros are the total missing values

y    = y(indx);
phat = phat(indx);

% trasnforming phat in a binary variable (the warning issuer variable)
yhat = (phat>x)+0;

% Matched Crises Events (A)
A = sum(y.*yhat);
% False Alarms
B = sum(yhat.*not(y));

% Missed Crises
C = sum(y.*not(yhat)); 
% Matched Tranquill periods
D = sum(not(y).*not(yhat));

% Ratio to be minimized
if A~=0 & D~=0
    BA = B/A+C/D;
else
    BA = 10;
end

if out_of_min==1
    %assignin('base','A',A);
    %assignin('base','B',B);
    %assignin('base','C',C);
    %assignin('base','D',D);
    BA=[A B; C D];
end
M=[A B; C D];
