%%%%%%%%%%%%%%% EXTREME VALUE THEORY %%%%%%%%%%%%%%%%

D = xlsread('Bloomberg EMBI Global Spreads MAT.xls','daily');  D(:,1)=[];
Dbin = xlsread('Bloomberg EMBI Global Spreads MAT.xls','daily bin');  Dbin(:,1)=[];
M = xlsread('Bloomberg EMBI Global Spreads MAT.xls','month avg'); M(:,1)=[];
Mbin = xlsread('Bloomberg EMBI Global Spreads MAT.xls','month bin'); Mbin(:,1)=[];
Y = xlsread('Bloomberg EMBI Global Spreads MAT.xls','yrly avg');  Y(:,1)=[];
Ybin = xlsread('Bloomberg EMBI Global Spreads MAT.xls','yrly bin');  Ybin(:,1)=[];


% Ljung Box Q Test for every country
for i = 1:size(Y,2)
    series = Y(:,i);
    series(isnan(series))=[];
    [HH ppval Qstat Crit] = lbqtest(series);
    Rslt(i,:) = [HH ppval Qstat Crit];
end

%%% Extreme Value Theroy
% Yearly Data
m=50; ci=.20;
[alpha, alphaV, YbinE, YThreshE] = extr_val(Y,m,60,ci);
suptitle('Yearly Data')
dy=Ybin(:)-YbinE(:);
dy(isnan(dy))=[];
TotObs=length(dy);

minus1 = (dy==-ones(TotObs,1));
Count1_minus1=sum(minus1);               % We miss a crisis    

plus1 = (dy==ones(TotObs,1));
Count1_plus1 = sum(plus1);               % ETV misses a crisis

thezeros = (dy==zeros(TotObs,1));
Count1_zeros = sum(thezeros);            % same result

disp(' ')
disp('Table 1 ')
disp('Comparison with ETV Yearly Data ')
disp(' ')
fprintf('Equal = %g   |   Adding = %g    |   Missing = %g    | Total = %g\n',[Count1_zeros Count1_plus1 Count1_minus1 TotObs])
fprintf('Equal = %5.2g |   Adding = %5.2g |   Missing = %5.2g | \n',[Count1_zeros/TotObs Count1_plus1/TotObs Count1_minus1/TotObs])
disp(' ')
disp(' ')

disp('Table 2 ')
disp('|----------------------------------------------------------------------|')
disp('|----------------------------------------------------------------------|')
fprintf('Yearly Data, Extreme Value Calculated Threshold = %g \n',YThreshE)
disp('|----------------------------------------------------------------------|')
break
% Monthly Data
m=400; ci=.2;
[alpha, alphaV, MbinE, MThreshE] = extr_val(M,m,600,ci);
%suptitle('Monthly Data')
fprintf('Monthly Data, Extreme Value Calculated Threshold = %g \n',MThreshE)
disp('|----------------------------------------------------------------------|')
disp('|----------------------------------------------------------------------|')
dy=Mbin(:)-MbinE(:);
dy(isnan(dy))=[];
TotObs=length(dy);

minus1 = (dy==-ones(TotObs,1));
Count1_minus1=sum(minus1);               % We miss a crisis    

plus1 = (dy==ones(TotObs,1));
Count1_plus1 = sum(plus1);               % ETV misses a crisis

thezeros = (dy==zeros(TotObs,1));
Count1_zeros = sum(thezeros);            % same result

disp(' ')
disp('Table 1 ')
disp('Comparison with ETV Monthly Data')
disp(' ')
fprintf('Equal = %g   |   Adding = %g    |   Missing = %g    | Total = %g\n',[Count1_zeros Count1_plus1 Count1_minus1 TotObs])
fprintf('Equal = %5.2g |   Adding = %5.2g |   Missing = %5.2g | \n',[Count1_zeros/TotObs Count1_plus1/TotObs Count1_minus1/TotObs])
disp(' ')
disp(' ')

% Daily Data
m=9000; ci=.1;
[alpha, alphaV, DbinE, DThreshE] = extr_val(D,m,18000,ci);
%suptitle('Daily Data')
fprintf('Daily Data, Extreme Value Calculated Threshold = %g \n',DThreshE)
disp('|----------------------------------------------------------------------|')
disp('|----------------------------------------------------------------------|')
dy=Dbin(:)-DbinE(:);
dy(isnan(dy))=[];
TotObs=length(dy);

minus1 = (dy==-ones(TotObs,1));
Count1_minus1=sum(minus1);               % We miss a crisis    

plus1 = (dy==ones(TotObs,1));
Count1_plus1 = sum(plus1);               % ETV misses a crisis

thezeros = (dy==zeros(TotObs,1));
Count1_zeros = sum(thezeros);            % same result

disp(' ')
disp('Table 1 ')
disp('Comparison with ETV Daily Data')
disp(' ')
fprintf('Equal = %g   |   Adding = %g    |   Missing = %g    | Total = %g\n',[Count1_zeros Count1_plus1 Count1_minus1 TotObs])
fprintf('Equal = %5.2g |   Adding = %5.2g |   Missing = %5.2g | \n',[Count1_zeros/TotObs Count1_plus1/TotObs Count1_minus1/TotObs])
disp(' ')
disp(' ')
