% Andrea Pescatori and Amadou Sy copyright, July 2003

% Loading xls spreadsheets data file (that already contains binary variables built using the 1000 basis points threshold).
% set_thresh     = 0 (dafault threshold selected); = 1 (you will choose)
% set_pic        = [1 1]; (doing pics of spreads and crises events respectively otherwise set 0) 
% set_print      = [0 0]; (printing pics of spreads and crises events respectively otherwise set 0)
% set_print2file = 0;     (printing to a .gs file pics of spreads and crises events respectively otherwise set 0)

set_thresh     = 0;
set_pic        = [0 0];
set_print      = [1 1];
set_print2file = 0;

[info1 info2]=xlsfinfo('Bloomberg EMBI Global Spreads MAT.xls');

nsheets=size(info2,2)-1;   % number of spreadsheets in the file (last one is a description sheet)
DataM=cell(nsheets,1);     % initializing the cell array 
for i=1:nsheets
    dinfo=char(info2(i)); 
    DataM{i} = xlsread('Bloomberg EMBI Global Spreads MAT.xls',dinfo);
end

Ndata=size(DataM{1},2)-1;  % N.B. I assume all the sheets have the same number of series + dates

datanames=cell(Ndata,1);

datanames{1,1}='ALG';   datanames{2,1}='ARG';
datanames{3,1}='BLG';   datanames{4,1}='BRA';
datanames{5,1}='CDI';   datanames{6,1}='CHI';
datanames{7,1}='CHN';   datanames{8,1}='COL';
datanames{9,1}='CRO';   datanames{10,1}='DOR';
datanames{11,1}='ECU';  datanames{12,1}='EGY';
datanames{13,1}='ELS';  datanames{14,1}='HNG';
datanames{15,1}='KOR';  datanames{16,1}='LEB';
datanames{17,1}='MAL';  datanames{18,1}='MEX';
datanames{19,1}='MOR';  datanames{20,1}='NIG';
datanames{21,1}='PAK';  datanames{22,1}='PAN';
datanames{23,1}='PER';  datanames{24,1}='PHL';
datanames{25,1}='POL';  datanames{26,1}='RUS';
datanames{27,1}='SAF';  datanames{28,1}='THL';
datanames{29,1}='TUN';  datanames{30,1}='TUR';
datanames{31,1}='UKR';  datanames{32,1}='URG';
datanames{33,1}='VEN'; 

freq=char('Daily','Daily','Weekly','Weekly','Monthly','Monthly','Qarterly','Quarterly','Semiannual','Semiannual','Annual','Annual');

% Reconstructing the binary variables
if set_thresh==1
    threshold=input('your desired threshold = ');
    for i=1:2:nsheets                  % odd spreadsheets are the row data on spreads
        d = DataM{i};
        k1 = not(isnan(d(:,2:end)));   % logical array
        k1 = k1+0;                     % double array
        k2 = d(:,2:end)>=threshold;
        d(:,2:end)  = k2./k1;
        DataM{i+1} = d;
    end
else
    threshold=1000;
end


% plotting the spreads
if set_pic(1)==1 | set_print(2)==1
    for i=1:2:nsheets
        backtonum=DataM{i};
        mydate=backtonum(:,1);
        for j=1:3
            figure
            for k=1:11
                %fobj=fints(mydate,backtonum(:,1+k+(j-1)*11),datanames(k+(j-1)*11),freq(i));
                fobj=fints(mydate,backtonum(:,1+k+(j-1)*11));
                subplot(3,4,k)
                plot(fobj)
                legend('off')
                xlabel(datanames(k+(j-1)*11),'FontSize',7)
                h=gca;
                xtk=get(h,'XTick');
                ftk=get(h,'FontSize');
                ult=length(xtk);
                xtknew=linspace(xtk(1),xtk(ult),3);
                xlabnew=datestr(xtknew);
                xlabnew=xlabnew(:,[4:6 10 11]);
                set(h,'XTick',xtknew);
                set(h,'XTickLabel',xlabnew);
                set(h,'FontSize',7);
                hold on
                vv=axis; nth=10;
                if vv(4)>threshold
                    thresx=linspace(vv(1),vv(2),nth);
                    thresy=threshold.*ones(1,nth);
                    plot(thresx,thresy,'Color','r','LineWidth',1.8)
                end
                hold off
            end
            suptitle([freq(i,:), ' Spreads Values', '     pag',num2str(j),'of3'])
            if set_print(1)==1;
                print
                if set_print2file==1
                    print('-dtiff','-r200',['spreads', num2str(i),'_', num2str(j)])
                end
                if set_pic(1)==0
                    close
                end
            end
        end
    end
end

% plotting the binary variable (the crises)
if set_pic(2)==1 | set_print(2)==1;
    for i=2:2:nsheets
        backtonum=DataM{i};
        mydate=backtonum(:,1);
        for j=1:3
            figure
            for k=1:11
                %           fobj=fints(mydate,backtonum(:,k+(j-1)*11),datanames(k+(j-1)*11),freq(i));
                fobj=fints(mydate,backtonum(:,1+k+(j-1)*11));
                subplot(3,4,k)
                plot(fobj,'.')
                legend('off')
                xlabel(datanames(k+(j-1)*11),'FontSize',7)
                v=axis; 
                v(3:4)=[-1 2];
                axis(v)
                h=gca;
                xtk=get(h,'XTick');
                ftk=get(h,'FontSize');
                ult=length(xtk);
                xtknew=linspace(xtk(1),xtk(ult),3);
                xlabnew=datestr(xtknew);
                xlabnew=xlabnew(:,[4:6 10 11]);
                set(h,'XTick',xtknew);
                set(h,'XTickLabel',xlabnew);
                set(h,'FontSize',7);
                hold on
                vv=axis; nth=10;
                if vv(4)>threshold
                    thresx=linspace(vv(1),vv(2),nth);
                    thresy=threshold.*ones(1,nth);
                    plot(thresx,thresy,'Color','r','LineWidth',1.8)
                end
                hold off
            end
            suptitle([freq(i,:), 'Debt Crises ', '  Threshold=', num2str(threshold),'     pag',num2str(j),'of3'])
            if set_print(2)==1;
                print
                if set_print2file==1
                    print('-dtiff','-r200',['spreads', num2str(i),'_', num2str(j)])
                end
                if set_pic(2)==0
                    close
                end
            end
        end
    end
end

