%%%%%%%%%%%%%%%%%%%%%% Comparison using MRS_PS xls file %%%%%%%%%%%%%%%%%%%

%output: 2 entry table 

[info1 info2]=xlsfinfo('MRS_PS.xls');
nsheets=size(info2,2); 
DataM=cell(nsheets,1);     % initializing the cell array 
for i=1:nsheets
    dinfo=char(info2(i)); 
    DataM{i} = xlsread('MRS_PS.xls',dinfo);
end

%%%%%%%%%% averaging
% wkl_par=5;
% Tw=floor(ndim(1)/wkl_par);
% Resto=ndim(1)-Tw*wkl_par;
% dd=reshape(d(1:ndim(1)-Resto,:),Tw,ndim(2),wkl_par);
% meandd=mean(dd);
% meanR=mean(d(ndim(1)-Resto+1:end));
% d_avg=reshape(meandd,Tw,ndim(2));
% d_avg=[d_avg; meanR];
%%%%%%%%%%%

nan_y_indx=(not(isnan(DataM{nsheets})))+0;  % I take the NaN from the already calculated (by eviews) yearly values
nan_y_indx=nan_y_indx(:,2:end);

d = DataM{2}; % daily (5 days) averaged data
d = d(:,2:end);
ndim=size(d);
par=260;
d=(d>=1)+0;     % we substitute the NaN with zeros (Remember d must be the crisis not-crisis matrix)
Tw=floor(ndim(1)/par);
Resto=ndim(1)-Tw*par;
dresh=reshape(d(1:ndim(1)-Resto,:),par,Tw,ndim(2));
meandresh=mean(dresh);
meanR=mean(d(ndim(1)-Resto+1:end,:));
d_m=reshape(meandresh,Tw,ndim(2));
d_m=[d_m; meanR];
PesSy_A1=(d_m>0)+0;
warning off all
PesSy_A1=PesSy_A1./nan_y_indx;

d = DataM{4}; % monthly averaged data
d = d(:,2:end);
ndim=size(d);
par=12;
d=(d>=1)+0;     % we substitute the NaN with zeros (Remember d must be the crisis not-crisis matrix)
Tw=floor(ndim(1)/par);
Resto=ndim(1)-Tw*par;
dresh=reshape(d(1:ndim(1)-Resto,:),par,Tw,ndim(2));
meandresh=mean(dresh);
meanR=mean(d(ndim(1)-Resto+1:end,:));
d_m=reshape(meandresh,Tw,ndim(2));
d_m=[d_m; meanR];
PesSy_A2=(d_m>0)+0;
PesSy_A2=PesSy_A1./nan_y_indx;

PesSy_A3=DataM{nsheets}; % annual averaged data
PesSy_A3=PesSy_A3(:,2:end);
warning on all

% Cutting the 2003 (not available in MRS)

PesSy_A1=PesSy_A1(1:end-1,:);
PesSy_A2=PesSy_A2(1:end-1,:);
PesSy_A3=PesSy_A3(1:end-1,:);

%%%%%%%%%% Vectorization
MRS=DataM{1}; MRS=MRS(:,2:end);
vecMRS=MRS(:);
vecPS1=PesSy_A1(:);
vecPS2=PesSy_A2(:);
vecPS3=PesSy_A3(:);


dy=vecPS1-vecMRS;
dy(isnan(dy))=[];
TotObs=length(dy);

minus1 = (dy==-ones(TotObs,1));
Count1_minus1=sum(minus1);               % We miss a crisis    

plus1 = (dy==ones(TotObs,1));
Count1_plus1 = sum(plus1);               % MRS misses a crisis

thezeros = (dy==zeros(TotObs,1));
Count1_zeros = sum(thezeros);               % same result

disp(' ')
disp('Table1 ')
disp('Comparison with MRS starting by daily crisis definition')
disp(' ')
fprintf('Equal = %g   |   Adding = %g    |   Missing = %g    | Total = %g\n',[Count1_zeros Count1_plus1 Count1_minus1 TotObs])
fprintf('Equal = %5.2g |   Adding = %5.2g |   Missing = %5.2g | \n',[Count1_zeros/TotObs Count1_plus1/TotObs Count1_minus1/TotObs])
disp(' ')
disp(' ')

dy=vecPS2-vecMRS;
dy(isnan(dy))=[];
TotObs=length(dy);

minus1 = (dy==-ones(TotObs,1));
Count2_minus1=sum(minus1);               % We miss a crisis    

plus1 = (dy==ones(TotObs,1));
Count2_plus1 = sum(plus1);               % MRS misses a crisis

thezeros = (dy==zeros(TotObs,1));
Count2_zeros = sum(thezeros);               % same result


disp('Table2')
disp('Comparison with MRS starting by monthly-averaged crisis definition')
disp(' ')
fprintf('Equal = %g   |   Adding = %g    |   Missing = %g    | Total = %g\n',[Count2_zeros Count2_plus1 Count2_minus1 TotObs])
fprintf('Equal = %5.2g |   Adding = %5.2g |   Missing = %5.2g | \n',[Count2_zeros/TotObs Count2_plus1/TotObs Count2_minus1/TotObs])
disp(' ')
disp(' ')

dy=vecPS3-vecMRS;
dy(isnan(dy))=[];
TotObs=length(dy);

minus1 = (dy==-ones(TotObs,1));
Count3_minus1=sum(minus1);               % We miss a crisis    

plus1 = (dy==ones(TotObs,1));
Count3_plus1 = sum(plus1);               % MRS misses a crisis

thezeros = (dy==zeros(TotObs,1));
Count3_zeros = sum(thezeros);               % same result


disp('Table3 ')
disp('Comparison with MRS starting by yearly-averaged crisis definition')
disp(' ')
fprintf('Equal = %g   |   Adding = %g     |   Missing = %g    | Total = %g\n',[Count3_zeros Count3_plus1 Count3_minus1 TotObs])
fprintf('Equal = %5.2g |   Adding = %5.2g |   Missing = %5.2g | \n',[Count3_zeros/TotObs Count3_plus1/TotObs Count3_minus1/TotObs])
disp(' ')
disp(' ')



