function [alpha, alphaV, Znew, thresh] = extr_val(Z,m,h,ci)

z=Z(:);
[X_NaN indx]=sort(z);
X = X_NaN;
X(isnan(X))=[];
n_obs = length(X);
n_misng_val=length(X_NaN)-n_obs;

gama = (1/m)*sum(log(X(end-m+1:end)/X(end-m)));
alpha = 1/gama;

L = min(h, n_obs-1); 
for j = 2:L
    mm = j;
gamaV(j-1) = (1/mm)*sum(log(X(end-mm+1:end)/X(end-mm)));
end
alphaV = ones(L-1,1)./gamaV';
%plot(2:L,gamaV,'LineWidth',2.5)
%xlabel('m')
%ylabel('estimated 1 over alphas')
%title('Plotting Estimated Alphas w.r.t m')
%grid

%% checking m
st=3;
for j = st:L-2
    trend = 1:j;
    y = gamaV(1:j)';
    Matrix_X = [ones(length(y),1), trend'];
    [b,bint] = regress(y,Matrix_X,ci);
    dyhatL(j-st+1) = [1 j+1]*bint(:,1);%-gamaV(j+1);
    dyhat(j-st+1)  = [1 j+1]*b ;%- gamaV(j+1);
    dyhatU(j-st+1) = [1 j+1]*bint(:,2);%-gamaV(j+1);
    if j/100==floor(j/100), disp(j),end
end
figure
tx = st:L-2;
plot(tx,dyhatL,tx,dyhat,tx,dyhatU)
hold on
plot(2:L,gamaV,'LineWidth',2.5,'Color','b')
xlabel('m')
ylabel('estimated 1 over alphas')
title('Plotting Estimated Alphas w.r.t m and ILS for the forecast')
grid


rc = size(Z);

z(not(isnan(z)))         = zeros(sum(not(isnan(z))),1);
z(indx(n_obs-m+1:n_obs)) = ones(m,1);
Znew = reshape(z,rc(1),rc(2));    % New Binary Crisis Panel

% Getting the Implied Threshold
thresh = X(end-m);