%%%% Kernel Density Pictures

pp=0:10:5000;
n1 = pdf('Normal',pp,m1,sd1); % 3y avg
n2 = pdf('Normal',pp,m2,sd2); % 5y avg
n3 = pdf('Normal',pp,m3,sd3); % Y
n0 = pdf('Normal',pp,m0,sd0); % M

% Pooled Yearly Data
figure
[f1,xi1]=ksdensity(v_3,'width',75,'npoints',1000,'kernel','epanechinikov');
plot(xi1,f1,'LineWidth',2),hold on 
text(750,9e-4,' \leftarrow DKernel','FontSize',10)
plot(pp,n3,'LineWidth',1,'Color','r')
text(1600,3e-4,' \leftarrow Normal','FontSize',10)
title('Pooled Spreads Kernel Density')
xlabel('Spreads')
ylabel('epanechinikov, normal, box, triangle Kernels')
grid
[f1,xi1]=ksdensity(v_3,'width',75,'npoints',1000,'kernel','normal');plot(xi1,f1)
[f1,xi1]=ksdensity(v_3,'width',75,'npoints',1000,'kernel','box');plot(xi1,f1)
[f1,xi1]=ksdensity(v_3,'width',75,'npoints',1000,'kernel','triangle');plot(xi1,f1)
h1=gca;
xlim=[-100, 6000];
set(h1,'XLim',xlim);
ylim=get(gca,'YLim');
line([1000 1000],ylim,'Color','k')
hold off

% 5 Years Average Data
figure
[f1,xi1]=ksdensity(v_1,'width',100,'npoints',1000,'kernel','epanechinikov');plot(xi1,f1,pp,n1),
title('3 Year Average Spreads Kernel Density'), 
xlabel('Spreads')
ylabel('epanechinikov, normal, box, triangle Kernels')
grid,hold on
%[f1,xi1]=ksdensity(v_1,'width',100,'npoints',1000,'kernel','normal');plot(xi1,f1)
%[f1,xi1]=ksdensity(v_1,'width',100,'npoints',1000,'kernel','box');plot(xi1,f1)
%[f1,xi1]=ksdensity(v_1,'width',100,'npoints',1000,'kernel','triangle');plot(xi1,f1)
h1=gca;
set(h1,'XLim',xlim);
hold off

% 3 Years Average Data
figure
[f1,xi1]=ksdensity(v_2,'width',100,'npoints',1000,'kernel','epanechinikov');plot(xi1,f1,pp,n2)
title('5 Year Average Spreads Kernel Density')
xlabel('Spreads')
ylabel('epanechinikov, normal, box, triangle Kernels')
grid,hold on
%[f1,xi1]=ksdensity(v_2,'width',100,'npoints',1000,'kernel','normal');plot(xi1,f1)
%[f1,xi1]=ksdensity(v_2,'width',100,'npoints',1000,'kernel','box');plot(xi1,f1)
%[f1,xi1]=ksdensity(v_2,'width',100,'npoints',1000,'kernel','triangle');plot(xi1,f1)
h1=gca;
set(h1,'XLim',xlim);
hold off

% Pooled Monthly Data
figure
[f1,xi1]=ksdensity(v_0,'width',25,'npoints',1000,'kernel','epanechinikov');plot(xi1,f1,pp,n0),
title('Pooled Monthly Spreads Kernel Density'), 
xlabel('Spreads')
ylabel('epanechinikov, normal, box, triangle Kernels')
grid,hold on
[f1,xi1]=ksdensity(v_0,'width',25,'npoints',1000,'kernel','normal');plot(xi1,f1)
[f1,xi1]=ksdensity(v_0,'width',25,'npoints',1000,'kernel','box');plot(xi1,f1)
[f1,xi1]=ksdensity(v_0,'width',25,'npoints',1000,'kernel','triangle');plot(xi1,f1)
h1=gca;
set(h1,'XLim',xlim);
hold off

% Daily Data
figure
[f1,xi1]=ksdensity(v_d,'width',25,'npoints',1000,'kernel','epanechinikov');plot(xi1,f1,pp,n0),
title('Pooled Daily Spreads Kernel Density'), 
xlabel('Spreads')
ylabel('epanechinikov, normal, box, triangle Kernels')
grid,hold on
[f1,xi1]=ksdensity(v_d,'width',25,'npoints',1000,'kernel','normal');plot(xi1,f1)
[f1,xi1]=ksdensity(v_d,'width',25,'npoints',1000,'kernel','box');plot(xi1,f1)
[f1,xi1]=ksdensity(v_d,'width',25,'npoints',1000,'kernel','triangle');plot(xi1,f1)
text(750,9e-4,' \leftarrow DKernels','FontSize',10)
text(1600,3e-4,' \leftarrow Normal','FontSize',10)
h1=gca;
set(h1,'XLim',xlim);
ylim=get(gca,'YLim');
line([1000 1000],ylim,'Color','k')
hold off
