%%%%%%%%%%%%%%%% MCMC FOR TAILS

fit_tab=0;
pics=1;
MCMC1=0; MCMC2=0;
MCMC3=0; MCMC4=0;

v_1 = xlsread('PooledAvgSpread.xls','3 avg');
v_2 = xlsread('PooledAvgSpread.xls','5 avg');
v_3 = xlsread('PooledAvgSpread.xls','Total');
M = xlsread('Bloomberg EMBI Global Spreads MAT.xls','month avg'); M(:,1)=[]; vec_M=M(:);
D = xlsread('Bloomberg EMBI Global Spreads MAT.xls','daily'); D(:,1)=[]; vec_D=D(:);;
%Mbin = xlsread('Bloomberg EMBI Global Spreads MAT.xls','month bin'); Mbin(:,1)=[];
%Y = xlsread('Bloomberg EMBI Global Spreads MAT.xls','yrly avg');  Y(:,1)=[];
%Ybin = xlsread('Bloomberg EMBI Global Spreads MAT.xls','yrly bin');  Ybin(:,1)=[];

v_0 = vec_M;
v_d = vec_D;

% getting rid of the NaN
v_1(isnan(v_1))=[];     
v_2(isnan(v_2))=[];
v_3(isnan(v_3))=[];
v_0(isnan(v_0))=[];
v_d(isnan(v_d))=[];

m1=mean(v_1);
m2=mean(v_2);
m3=mean(v_3);
m0=mean(v_0);
md=mean(v_d);

sd1=std(v_1);
sd2=std(v_2);
sd3=std(v_3);
sd0=std(v_0);
sdd=std(v_d);


%%%% Results from fittin an Ext. Value Distr. %%%
if fit_tab==1
    
    % ML Fitting
    q1 = weibfit(v_1);
    q2 = weibfit(v_2);
    q3 = weibfit(v_3);
    
    % 90th Percentile
    
    p90th_1 = weibinv(.9,q1(1),q1(2));
    p90th_2 = weibinv(.9,q2(1),q2(2));
    p90th_3 = weibinv(.9,q3(1),q3(2));
    
    p75th_1 = weibinv(.75,q1(1),q1(2));
    p75th_2 = weibinv(.75,q2(1),q2(2));
    p75th_3 = weibinv(.75,q3(1),q3(2));
    
    disp(' ')
    disp('|----------------------------------------------------------------------|')
    disp('|----------------------------------------------------------------------|')
    disp('| TABLE1: WEIBUL THRESHOLD, 90th PERCENTILE and 75th PERCENTILE')
    disp('|---------------- ')
    disp('| 90th percentile' ) 
    fprintf(' Pooled Spreads: %g;   5 years average: %g;   3 years average: %g \n',p90th_1,p90th_3,p90th_2)
    disp('|---------------- ')
    disp('| 75th percentile')
    fprintf(' Pooled Spreads: %g;   5 years average: %g;   3 years average: %g \n',p75th_1,p75th_3,p75th_2)
    disp('|----------------------------------------------------------------------|')
    disp('|----------------------------------------------------------------------|')
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if pics==1
    ksd_pics
end

                                   %%%% Monthly Values for Spreads %%%%%%
                                   
if MCMC1 == 0
    %load good_monthly
else                                   
    % Getting the Density Kernel Estimation
    [f1M,xi1M]=ksdensity(vec_M,'width',50,'npoints',5000,'kernel','epanechinikov');
    
    k1=25; F=1250; J=5;    
    X1 = thresh_est(f1M,xi1M,k1,F,J);
end
    
    
                                   %%%% Yearly Values for Spreads %%%%%%

if MCMC2 == 0
%    load good_yearly
else                                   
    vec_M=v_1;
    vec_M(isnan(vec_M))=[];
    
    % Getting the Density Kernel Estimation
    [f1M,xi1M]=ksdensity(vec_M,'width',100,'npoints',5000,'kernel','epanechinikov');
    
    k1=25; F=1250; J=5;
    X2 = thresh_est(f1M,xi1M,k1,F,J);
end


                                   %%%% Yearly Values for Spreads 3 Avg.%%%%%%

if MCMC3 == 0
%    load good_yearly5
else                                   
    vec_M=v_2;
    vec_M(isnan(vec_M))=[];
    
    % Getting the Density Kernel Estimation
    [f1M,xi1M]=ksdensity(vec_M,'width',100,'npoints',5000,'kernel','epanechinikov');
    
    k1=25; F=1350; J=2.5;
    X3 = thresh_est(f1M,xi1M,k1,F,J);
end


                                   %%%% Yearly Values for Spreads 5 Avg. %%%%%%

if MCMC4 == 0
%    load good_yearly3
else                                   
    vec_M=v_3;
    vec_M(isnan(vec_M))=[];
    
    % Getting the Density Kernel Estimation
    [f1M,xi1M]=ksdensity(vec_M,'width',100,'npoints',5000,'kernel','epanechinikov');
    
    k1=25; F=1250; J=5;
    X4 = thresh_est(f1M,xi1M,k1,F,J);
end
