*! 95% confidence probabilities, for xtgee probit
quietly {
egen uncpr=mean(y)

predict ihat, index
predict error, stdp
predict phat, rate
gen lb = ihat - invnorm(.975)*error
gen ub = ihat + invnorm(.975)*error
gen plb = norm(lb)
gen pub = norm(ub)
drop ihat

gen	yhatL	=1	if	plb	>	uncpr	&	plb	!=	.
replace	yhatL	=0	if	plb	<=	uncpr	&	plb	!=	.
gen	yhat	=1	if	phat	>	uncpr	&	phat	!=	.
replace	yhat	=0	if	phat	<=	uncpr	&	phat	!=	.
gen	yhatU	=1	if	pub	>	uncpr	&	pub	!=	.
replace	yhatU	=0	if	pub	<=	uncpr	&	pub	!=	. 

gen	dyL	=2*yhatL+y								
gen	dy	=2*yhat+y								
gen	dyU	=2*yhatU+y 
tempname obs C NC
xtsum dy
scalar `obs'=r(N)
count if y == 0 & yhat!=.
scalar `NC'=r(N)
count if y == 1 & yhat!=.
scalar `C'=r(N)
}
count	if dy	==0	
display "Tranquils Matched  to Tot Obs = " r(N)/`obs' " to Num Tranq = " r(N)/`NC'  " 			
				
count	if dy	==1
display "Missed Crises to Tot Obs = " r(N)/ `obs' " to Num Tranq = " r(N)/`NC'  "														

count	if dy	==2		
display "False Alarms to Tot Obs = " r(N)/`obs' " to Num Crises = " r(N)/`C'  "							

count	if dy	==3		
display "Crises Matched to Tot Obs = " r(N)/`obs' " to Num Crises = " r(N)/`C'  " 							

xttrans y
xttrans yhat						
							



